#!/bin/bash

# CC BY-NC-SA 4.0 Felix Baumann
# https://creativecommons.org/licenses/by-nc-sa/4.0
# 2017
# Script is provided as supplemental material
# for the article F. W. Baumann and D. Roller "Overview of German Additive Manufacturing Companies"

# This script parses information on a specific website from the Internet archive.
# List when it was first indexed and last, also how often it is indexed.

URL=${1}

DATES=$( wget -O - -q "http://web.archive.org/__wb/sparkline?url=${URL}&output=json" )
FIRST_D=$( echo "${DATES}" | sed -e "s/,/,\n/g" | grep "first_ts" | awk -F"\"" '{ print $4 }' )
FIRST_DATE=$( date -d "${FIRST_D:0:8} ${FIRST_D:8:2}:${FIRST_D:10:2}:${FIRST_D:12:2}" +"%Y-%m-%d %H:%M:%S" 2> /dev/null )

LAST_D=$( echo "${DATES}" | sed -e "s/,/,\n/g" | grep "last_ts" | awk -F"\"" '{ print $4 }' )
LAST_DATE=$( date -d "${LAST_D:0:8} ${LAST_D:8:2}:${LAST_D:10:2}:${LAST_D:12:2}" +"%Y-%m-%d %H:%M:%S" 2> /dev/null  )

RETRIEVE_TIMES=$( bc <<< "$( echo "${DATES}" | sed -e "s/years/\nyears/g" | grep "years" | awk -F"{" '{ print $2 }' | sed -e "s/\[/\n[/g;s/\]/\]\n/g" | grep "\[" | tr "," "+" | tr -d "\[\]" | tr "\n" "+" | sed -e "s/$/0/g" )" )

echo "${FIRST_DATE:-N/A};${LAST_DATE:-N/A};${RETRIEVE_TIMES:-N/A}"
