#!/bin/bash

# CC BY-NC-SA 4.0 Felix Baumann
# https://creativecommons.org/licenses/by-nc-sa/4.0
# 2017
# Script is provided as supplemental material
# for the article F. W. Baumann and D. Roller "Overview of German Additive Manufacturing Companies"

# This script takes the accumulated website and generates a list
# of most common words with stopwords excluded

LANG=de_DE.UTF-8

INP=${1}
STOPLIST=[SPECIFY BASE DIR HERE]/stoplist.txt

WORDS=$( cat ${INP} | tr -d "\r" | sed -e "s/[\t ]\{2,\}/ /g;s/^ //g" | grep -v "^$" | tr " " "\n" | tr -d "\(\)" | egrep -v "^(•|\&|_|-|http| |\t| |©|\+|\[|=|═|\{)" | grep -v "^[0-9]*$" | tr "[A-Z]" "[a-z]" | grep -v "^[^a-z0-9]" | tr -d ".," | sed -e "s/[^a-z0-9üöäÄÜÖßāáǎàēéěèīíǐìōóǒòūúǔùǖǘǚǜĀÁǍÀĒÉĚÈĪÍǏÌŌÓǑÒŪÚǓÙǕǗǙǛ]//g" | grep -v "^[0-9]\{1,\}$" )
T=$( mktemp )
for w in ${WORDS}; do
	if [ $( grep -m 1 -c "${w:- }" ${STOPLIST} 2>/dev/null ) -eq 0 ]; then
		echo "${w}" >> ${T}
	fi
done

WC=$( wc -l ${T} | awk '{ print $1 }' )
WORDS=$( sort ${T} | uniq -c | sort -nr | head -10l | sed -e "s/^[\t ]*//g" | tr "\n" ";" | tr " " ":" )
echo "${WC};${WORDS}"
